import { OnInit, OnDestroy, SimpleChanges, OnChanges, ChangeDetectorRef, AfterViewChecked, EventEmitter, ElementRef } from '@angular/core';
import { ControlValueAccessor, Validator, UntypedFormControl } from '@angular/forms';
import { DropdownSettings } from './multiselect.interface';
import { ListFilterPipe } from './list-filter';
import { Item, Badge, Search } from './menu-item';
import { Subscription, Subject } from 'rxjs';
import * as i0 from "@angular/core";
import * as i1 from "./clickOutside";
import * as i2 from "./list-filter";
import * as i3 from "./menu-item";
import * as i4 from "@angular/common";
import * as i5 from "@angular/forms";
import * as i6 from "./virtual-scroll/virtual-scroll";
export declare const DROPDOWN_CONTROL_VALUE_ACCESSOR: any;
export declare const DROPDOWN_CONTROL_VALIDATION: any;
export declare class AngularMultiSelect implements OnInit, ControlValueAccessor, OnChanges, Validator, AfterViewChecked, OnDestroy {
    _elementRef: ElementRef;
    private cdr;
    private filterPipe;
    data: Array<any>;
    settings: DropdownSettings;
    loading: boolean;
    onSelect: EventEmitter<any>;
    onDeSelect: EventEmitter<any>;
    onSelectAll: EventEmitter<Array<any>>;
    onDeSelectAll: EventEmitter<Array<any>>;
    onOpen: EventEmitter<any>;
    onClose: EventEmitter<any>;
    onScrollToEnd: EventEmitter<any>;
    onFilterSelectAll: EventEmitter<Array<any>>;
    onFilterDeSelectAll: EventEmitter<Array<any>>;
    onAddFilterNewItem: EventEmitter<any>;
    onGroupSelect: EventEmitter<any>;
    onGroupDeSelect: EventEmitter<any>;
    itemTempl: Item;
    badgeTempl: Badge;
    searchTempl: Search;
    searchInput: ElementRef;
    selectedListElem: ElementRef;
    dropdownListElem: ElementRef;
    cuppaDropdown: ElementRef;
    onEscapeDown(event: KeyboardEvent): void;
    onScroll(event: any): void;
    virtualdata: any;
    searchTerm$: Subject<string>;
    selectedItems: Array<any>;
    isActive: boolean;
    isSelectAll: boolean;
    isFilterSelectAll: boolean;
    isInfiniteFilterSelectAll: boolean;
    groupedData: Array<any>;
    filter: any;
    chunkArray: any[];
    scrollTop: any;
    chunkIndex: any[];
    cachedItems: any[];
    groupCachedItems: any[];
    totalRows: any;
    itemHeight: any;
    screenItemsLen: any;
    cachedItemsLen: any;
    totalHeight: any;
    scroller: any;
    maxBuffer: any;
    lastScrolled: any;
    lastRepaintY: any;
    selectedListHeight: any;
    filterLength: any;
    infiniteFilterLength: any;
    viewPortItems: any;
    item: any;
    dropdownListYOffset: number;
    subscription: Subscription;
    dropDownWidth: number;
    dropDownTop: any;
    dropDownBottom: any;
    dropDownLeft: number;
    id: any;
    defaultSettings: DropdownSettings;
    randomSize: boolean;
    parseError: boolean;
    filteredList: any;
    virtualScroollInit: boolean;
    private virtualScroller;
    isDisabledItemPresent: boolean;
    constructor(_elementRef: ElementRef, cdr: ChangeDetectorRef, filterPipe: ListFilterPipe);
    ngOnInit(): void;
    onKeyUp(evt: any): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngDoCheck(): void;
    ngAfterViewInit(): void;
    ngAfterViewChecked(): void;
    onItemClick(item: any, index: number, evt: Event): void;
    validate(c: UntypedFormControl): any;
    private onTouchedCallback;
    private onChangeCallback;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    trackByFn(index: number, item: any): any;
    isSelected(clickedItem: any): boolean;
    addSelected(item: any): void;
    removeSelected(clickedItem: any): void;
    toggleDropdown(evt: any): void;
    openDropdown(): void;
    closeDropdown(): void;
    closeDropdownOnClickOut(): void;
    toggleSelectAll(event: any): void;
    filterGroupedList(): void;
    toggleFilterSelectAll(): void;
    toggleInfiniteFilterSelectAll(): void;
    clearSearch(): void;
    onFilterChange(data: any): void;
    cloneArray(arr: any): any;
    updateGroupInfo(item: any): void;
    transformData(arr: Array<any>, field: any): Array<any>;
    filterInfiniteList(evt: any): void;
    resetInfiniteSearch(): void;
    onScrollEnd(e: any): void;
    ngOnDestroy(): void;
    selectGroup(item: any): void;
    addFilterNewItem(): void;
    calculateDropdownDirection(): void;
    openTowardsTop(value: boolean): void;
    clearSelection(e?: any): void;
    filteritems(evt: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AngularMultiSelect, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AngularMultiSelect, "angular2-multiselect", never, { "data": { "alias": "data"; "required": false; }; "settings": { "alias": "settings"; "required": false; }; "loading": { "alias": "loading"; "required": false; }; }, { "onSelect": "onSelect"; "onDeSelect": "onDeSelect"; "onSelectAll": "onSelectAll"; "onDeSelectAll": "onDeSelectAll"; "onOpen": "onOpen"; "onClose": "onClose"; "onScrollToEnd": "onScrollToEnd"; "onFilterSelectAll": "onFilterSelectAll"; "onFilterDeSelectAll": "onFilterDeSelectAll"; "onAddFilterNewItem": "onAddFilterNewItem"; "onGroupSelect": "onGroupSelect"; "onGroupDeSelect": "onGroupDeSelect"; }, ["itemTempl", "badgeTempl", "searchTempl"], never, false, never>;
}
export declare class AngularMultiSelectModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<AngularMultiSelectModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<AngularMultiSelectModule, [typeof AngularMultiSelect, typeof i1.ClickOutsideDirective, typeof i1.ScrollDirective, typeof i1.styleDirective, typeof i2.ListFilterPipe, typeof i3.Item, typeof i3.TemplateRenderer, typeof i3.Badge, typeof i3.Search, typeof i1.setPosition, typeof i3.CIcon], [typeof i4.CommonModule, typeof i5.FormsModule, typeof i6.VirtualScrollerModule], [typeof AngularMultiSelect, typeof i1.ClickOutsideDirective, typeof i1.ScrollDirective, typeof i1.styleDirective, typeof i2.ListFilterPipe, typeof i3.Item, typeof i3.TemplateRenderer, typeof i3.Badge, typeof i3.Search, typeof i1.setPosition, typeof i3.CIcon]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<AngularMultiSelectModule>;
}
